package com.ruoyi.doubledefense.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.ruoyi.common.constant.DeletedEnum;
import com.ruoyi.common.utils.uuid.UUID;
import com.ruoyi.doubledefense.domain.RiskUnit;
import com.ruoyi.doubledefense.dto.RiskUnitDTO;
import com.ruoyi.doubledefense.dto.res.RiskUnitResultDTO;
import com.ruoyi.doubledefense.dtoGov.RiskUnitDTOGov;
import com.ruoyi.doubledefense.mapper.RiskUnitMapper;
import com.ruoyi.doubledefense.service.IRiskUnitService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.List;

/**
 * 风险分析单元Service业务层处理
 *
 * @author ruoyi
 * @date 2023-08-03
 */
@Service
public class RiskUnitServiceImpl implements IRiskUnitService {
    @Autowired
    private RiskUnitMapper riskUnitMapper;


    /**
     * 重预防汇聚计算节点
     * 查询风险分析单元
     *
     * @param riskUnit
     * @return
     */
    @Override
    public PageInfo<RiskUnitDTOGov> govSelectRiskUnitList(RiskUnitDTOGov riskUnit) {
        PageHelper.startPage(riskUnit.getPageNo(), riskUnit.getPageSize());

        List<RiskUnitDTOGov> riskUnitDTOGovList = riskUnitMapper.govSelectRiskUnitList(riskUnit);

        PageInfo<RiskUnitDTOGov> pageInfo = new PageInfo<>(riskUnitDTOGovList);

        return pageInfo;
    }

    /**
     * 查询风险分析单元
     *
     * @param id 风险分析单元主键
     * @return 风险分析单元
     */
    @Override
    public RiskUnitResultDTO selectRiskUnitById(String id) {
        RiskUnitDTO riskUnitDTO = new RiskUnitDTO();
        riskUnitDTO.setId(id);
        List<RiskUnitResultDTO> riskUnitResultDTOS = riskUnitMapper.selectRiskUnitList(riskUnitDTO);
        if (CollectionUtils.isEmpty(riskUnitResultDTOS)) {
            return null;
        }
        return riskUnitResultDTOS.get(0);
    }

    /**
     * 查询风险分析单元列表
     *
     * @param riskUnitDTO 风险分析单元
     * @return 风险分析单元
     */
    @Override
    public List<RiskUnitResultDTO> selectRiskUnitList(RiskUnitDTO riskUnitDTO) {
        return riskUnitMapper.selectRiskUnitList(riskUnitDTO);
    }

    /**
     * 新增风险分析单元
     *
     * @param riskUnitDTO 风险分析单元
     * @return 结果
     */
    @Override
    public int insertRiskUnit(RiskUnitDTO riskUnitDTO) {
        RiskUnit riskUnit = new RiskUnit();
        BeanUtils.copyProperties(riskUnitDTO, riskUnit);
        riskUnit.setId(UUID.randomUUID().toString());
        riskUnit.setCreateDefault();
        return riskUnitMapper.insert(riskUnit);
    }

    /**
     * 修改风险分析单元
     *
     * @param riskUnitDTO 风险分析单元
     * @return 结果
     */
    @Override
    public int updateRiskUnit(RiskUnitDTO riskUnitDTO) {
        RiskUnit riskUnit = new RiskUnit();
        BeanUtils.copyProperties(riskUnitDTO, riskUnit);
        riskUnit.setUpdateDefault();
        return riskUnitMapper.updateById(riskUnit);
    }

    /**
     * 批量删除风险分析单元
     *
     * @param ids 需要删除的风险分析单元主键
     * @return 结果
     */
    @Override
    public int deleteRiskUnitByIds(String[] ids) {
        RiskUnit riskUnit = new RiskUnit();
        riskUnit.setUpdateDefault();
        riskUnit.setIsDel(DeletedEnum.INVALID.getValue());
        QueryWrapper<RiskUnit> queryWrapper = new QueryWrapper<>();
        queryWrapper.in("id", ids);
        return riskUnitMapper.update(riskUnit, queryWrapper);
    }


}
